
const fs = require('fs');
const openpgp  = require('openpgp')
const path = require('path')
const { readFileSync } = fs
const blessed = require('blessed');
const { utils: { parseKey }, Server } = require('ssh2');
const RE_SPECIAL =
// eslint-disable-next-line no-control-regex
  /[\x00-\x1F\x7F]+|(?:\x1B\[([0-9]{1,2}(;[0-9]{1,2})?)?[m|K])/g;
const MAX_MSG_LEN = 128;
const MAX_NAME_LEN = 10;
const PROMPT_NAME = `Enter a nickname to use (max ${MAX_NAME_LEN} chars): `;

const users = [];

function formatMessage(msg, output) {
  output.parseTags = true;
  msg = output._parseTags(msg);
  output.parseTags = false;
  return msg;
}

function userBroadcast(msg, source) {
  const sourceMsg = `> ${msg}`;
  const name = `{cyan-fg}{bold}${source.name}{/}`;
  msg = `: ${msg}`;
  for (const user of users) {
    const output = user.output;
    if (source === user)
      output.add(sourceMsg);
    else
      output.add(formatMessage(name, output) + msg);
  }
}

function localMessage(msg, source) {
  const output = source.output;
  output.add(formatMessage(msg, output));
}
function noop(v) {}
let known_keys = require('fs').readdirSync('./ssh_keys').map(dir => {
  const files = fs.readdirSync(path.join(__dirname, 'ssh_keys', dir))
  return {
    parsedKey: parseKey(fs.readFileSync(files.find(f => f.endsWith('.sshkey')))),
    armoredGPGKey: fs.readFileSync(files.find(f => f.endsWith('.asc')))
  }
})
new Server({ 
  hostKeys: [readFileSync('host.key')],
}, (client) => {
  let stream;
  let name;

  // client.on('authentication', (ctx) => {
  //   console.log(ctx, ctx.key, ctx.method)
  //   let nick = ctx.username;
  //   let prompt = PROMPT_NAME;
  //   let lowered;

  //   // Try to use username as nickname
  //   if (nick.length > 0 && nick.length <= MAX_NAME_LEN) {
  //     lowered = nick.toLowerCase();
  //     let ok = true;
  //     for (const user of users) {
  //       if (user.name.toLowerCase() === lowered) {
  //         ok = false;
  //         prompt = `That nickname is already in use.\n${PROMPT_NAME}`;
  //         break;
  //       }
  //     }
  //     if (ok) {
  //       name = nick;
  //       return ctx.accept();
  //     }
  //   } else if (nick.length === 0) {
  //     prompt = 'A nickname is required.\n' + PROMPT_NAME;
  //   } else {
  //     prompt = 'That nickname is too long.\n' + PROMPT_NAME;
  //   }

  //   if (ctx.method !== 'keyboard-interactive')
  //     return ctx.reject(['keyboard-interactive']);

  //   ctx.prompt(prompt, function retryPrompt(answers) {
  //     if (answers.length === 0)
  //       return ctx.reject(['keyboard-interactive']);
  //     nick = answers[0];
  //     if (nick.length > MAX_NAME_LEN) {
  //       return ctx.prompt(`That nickname is too long.\n${PROMPT_NAME}`,
  //                         retryPrompt);
  //     } else if (nick.length === 0) {
  //       return ctx.prompt(`A nickname is required.\n${PROMPT_NAME}`,
  //                         retryPrompt);
  //     }
  //     lowered = nick.toLowerCase();
  //     for (const user of users) {
  //       if (user.name.toLowerCase() === lowered) {
  //         return ctx.prompt(`That nickname is already in use.\n${PROMPT_NAME}`,
  //                           retryPrompt);
  //       }
  //     }
  //     name = nick;
  //     ctx.accept();
  //   });
  // })
  let username = null;
  let reject_on_connect = false;
  client.on('authentication', (ctx) => {
    let allowed = false;
    username = ctx.username;
    if (ctx.username == "gimmie-key") {
      allowed = true;
      ctx.accept();
return;
    }

    switch (ctx.method) {
      case 'password':
        // console.log('Not passwor')
        ctx.reject();
        break;
      case 'publickey':
        console.log(`pubkey`)
// let is_allowed = 
        // console.log(ctx.key.data.toString())
known_keys.forEach((info) => {
  let allowedPubKey = info.parsedKey
  if (ctx.key.algo !== allowedPubKey.type
    || !checkValue(ctx.key.data, allowedPubKey.getPublicSSH())
    || (ctx.signature && allowedPubKey.verify(ctx.blob, ctx.signature, ctx.hashAlgo) !== true)) {
  // do nothing;
  } else {
    allowed = true;
  }
})
        break;
      default:
        return ctx.reject();
    }

    if (allowed)
      ctx.accept();
    else {
      console.error(`no`, ctx.prompt)
      // ctx.prompt(`Your ssh key was not found/provided please add by sshing with the username gimmie-key`, () => {
      // ctx.reject();
      // })
      reject_on_connect = true;
      ctx.accept()
    }
  })
  .on('ready', () => {
    let rows;
    let cols;
    let term;
    
    client.once('session', (accept, reject) => {
      accept().once('pty', (accept, reject, info) => {
        rows = info.rows;
        cols = info.cols;
        term = info.term;
        accept && accept();
      }).on('window-change', (accept, reject, info) => {
        rows = info.rows;
        cols = info.cols;
        if (stream) {
          stream.rows = rows;
          stream.columns = cols;
          stream.emit('resize');
        }
        accept && accept();
      }).once('shell', (accept, reject) => {
        stream = accept();
        stream.name = name;
        stream.rows = rows || 24;
        stream.columns = cols || 80;
        stream.isTTY = true;
        stream.setRawMode = noop;
        stream.on('error', noop);
        if(reject_on_connect) {
stream.write("Your ssh key was not found/provided please add by sshing with the username gimmie-key`\n")
stream.end()
        }
        if(username == 'gimmie-key') {
          const screen = new blessed.screen({
            autoPadding: true,
            smartCSR: true,
            program: new blessed.program({
              input: stream,
              output: stream
            }),
            terminal: term || 'ansi'
          });
          const output = stream.output = new blessed.log({
            screen: screen,
            top: 0,
            left: 0,
            width: '100%',
            bottom: 2,
            scrollOnInput: true
          });
          screen.append(output);
  
          screen.append(new blessed.box({
            screen: screen,
            height: 1,
            bottom: 3,
            left: 0,
            width: '100%',
            type: 'line',
            ch: '='
          }));
  
          const input = new blessed.textarea({
            screen: screen,
            bottom: 0,
            height: 3,
            width: '100%',
            inputOnFocus: true
          });
          const btn = new blessed.button({
            screen, 
            bottom: 5,
            height: 2,
            mouse: true,
            keys: true,
            shrink: true,
            padding: {
              left: 1,
              right: 1
            },
            style: {
              bg: 'blue',
              focus: {
                bg: 'red'
              },
              hover: {
                bg: 'red'
              }
            },
            content: "submit",
            width: '10%',
          })
          screen.append(input);
          screen.append(btn)
          input.focus();
  output.add('Please send your public GPG key here! ')
  output.add(`Once you have pasted it click the red submit button`)
  output.add('You will then recive an email shortly pgp-signed with your ssh pirv key')
  // console.log(input)
  btn.on('press', async () => {
    console.debug(`#click`)
    let line = input.getValue()
    stream.lastInput = Date.now()
    // input.clearValue();
    // screen.render();
    if (!input.focused)
      input.focus();

    try {
      const key = await openpgp.readKey({ armoredKey: line })
      output.add(`PGP key added.`)
     console.log( key.getFingerprint(), key.users[0].userID.name)

     stream.end()
    } catch (e) {
      output.add(`Error! Your key is an invalid pgp key`)
      output.add(`> ${e.message}`)
    }
    // line = line.replace(RE_SPECIAL, '').trim();
    // if (line.length > MAX_MSG_LEN)
    //   line = line.substring(0, MAX_MSG_LEN);
    // if (line.length > 0) {
    //   if (line === '/quit' || line === '/exit')
    //     stream.end();
    //   else
    //     userBroadcast(line, stream);
    // }
  });
// stream.end()
        } else {
    
        users.push(stream);
        stream.lastInput = Date.now()
        

        const screen = new blessed.screen({
          autoPadding: true,
          smartCSR: true,
          program: new blessed.program({
            input: stream,
            output: stream
          }),
          terminal: term || 'ansi'
        });

        screen.title = 'SSH Chatting as ' + name;
        // Disable local echo
        screen.program.attr('invisible', true);

        const output = stream.output = new blessed.log({
          screen: screen,
          top: 0,
          left: 0,
          width: '100%',
          bottom: 2,
          scrollOnInput: true
        });
        screen.append(output);

        screen.append(new blessed.box({
          screen: screen,
          height: 1,
          bottom: 1,
          left: 0,
          width: '100%',
          type: 'line',
          ch: '='
        }));

        const input = new blessed.textbox({
          screen: screen,
          bottom: 0,
          height: 1,
          width: '100%',
          inputOnFocus: true
        });
        screen.append(input);

        input.focus();

        // Local greetings
        localMessage('{blue-bg}{white-fg}{bold}Welcome to SSH Chat!{/}\n'
                     + 'There are {bold}'
                     + (users.length - 1)
                     + '{/} other user(s) connected.\n'
                     + 'Type /quit or /exit to exit the chat.',
                     stream);

        // Let everyone else know that this user just joined
        for (const user of users) {
          const output = user.output;
          if (user === stream)
            continue;
          output.add(formatMessage('{green-fg}*** {bold}', output)
                     + name
                     + formatMessage('{/bold} has joined the chat{/}', output));
        }

        screen.render();
        // XXX This fake resize event is needed for some terminals in order to
        // have everything display correctly
        screen.program.emit('resize');
        setInterval(() => {  
if(Date.now() - stream.lastInput >= 60_000) {
  return stream.end();
}
        },1000)
        // Read a line of input from the user
        input.on('submit', (line) => {
          stream.lastInput = Date.now()
          input.clearValue();
          screen.render();
          if (!input.focused)
            input.focus();
          line = line.replace(RE_SPECIAL, '').trim();
          if (line.length > MAX_MSG_LEN)
            line = line.substring(0, MAX_MSG_LEN);
          if (line.length > 0) {
            if (line === '/quit' || line === '/exit')
              stream.end();
            else
              userBroadcast(line, stream);
          }
        });
      }
      });
    });
  }).on('close', () => {
    if (stream !== undefined) {
      users.splice(users.indexOf(stream), 1);
      // Let everyone else know that this user just left
      for (const user of users) {
        const output = user.output;
        output.add(formatMessage('{magenta-fg}*** {bold}', output)
                   + name
                   + formatMessage('{/bold} has left the chat{/}', output));
      }
    }
  }).on('error', (err) => {
    // Ignore errors
  });
}).listen(3001, function() {
  console.log('Listening on port ' + this.address().port);
});